<?php
/*! (c) 2024
 * Widget ZP - Widgets für Zeta Producer
 * widget-zp.de
 * 
 * Geocoding API für OpenStreetMap L
 * V2.2
 */
$results = [];

if (isset($_GET["s"]) && !empty($_GET["s"])) {
    ini_set("memory_limit", "128M");

    $search = strtolower(trim(strip_tags($_GET["s"])));
    $country = $_GET["country"];
    
    $lang = $_GET["lang"] ?? "de";
    $lang = strtolower(trim($lang));
    
    /* language selection */
    switch ($lang) {
        case "de":
            $pdo = new PDO('sqlite:cities_de.sqlite');
            break;
        
        case "en":
        default:
            $pdo = new PDO('sqlite:cities_en.sqlite');
            break;
    }
    
    $params = ["search" => $search . "%"];
    $sql = 'SELECT * FROM cities WHERE name LIKE :search ORDER BY name ASC LIMIT 200';
    
    if (!empty($country)) {
        $country = trim(strip_tags($country));
        $sql .= " AND country = :countrySearch";
        $params["countrySearch"] = $country;
    }

    $query = $pdo->prepare($sql);

    $query->execute($params);

    $results = $query->fetchAll(PDO::FETCH_ASSOC);
}

echo json_encode([
    "attribution" => "Data from https://github.com/lutangar/cities.json",
    "license" => "Creative Commons Attribution 3.0 License",
    "api" => "Widget ZP widget-zp.de",
    "apiVersion" => "2.2.0",
    "data" => array_values($results)
], JSON_PRETTY_PRINT);

exit;
